#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sbintree.h"

/*
 * Remove everything after the first newline in the string, including
 * the newline itself.
 */
int chomp (char *s) {
	char *nl = strchr(s, '\n');
	if (nl != NULL) {
		*nl = '\0';
		return 1;
	} else {
		return 0;
	}
}

int
main() {
	btnode *tree = NULL;
	#define INBUFSIZ 4096
	char inbuf[INBUFSIZ];
	btnode **nnode;

	while (1) {
		printf("? ");
		fflush(stdout);
		
		if (NULL == fgets(inbuf, INBUFSIZ, stdin)) break;
		chomp(inbuf);

		printf("Searching for <%s>\n", inbuf);
		nnode = rbsearch(&tree, inbuf);
		if (*nnode == NULL) {
			printf("<%s> not found -- inserting\n", inbuf);
			*nnode = newbtnode(inbuf);
			if (*nnode == NULL) {
				printf("Insertion failed!\n");
			}
		} else {
			printf("<%s> found\n", inbuf);
		}
	}
	return 0;
}
